<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	/*
		Classe représentant les importateurs
	*/
	class PolarisLinkSite
	{
		public $LinkID = NULL;
		public $LinkName = "Lien Polaris";

		public $LogDebug = false;

		public $ProductionURL = "";
		
		public $PolarisLicence = NULL;
		public $PolarisVersion = NULL;

		public $LevelName1 = "Niveau n°1";
		public $LevelName2 = "Niveau n°2";
		public $LevelName3 = "Niveau n°3";
		public $LevelName4 = "Niveau n°4";

		public $CategoryName1 = "Catégorie n°1";
		public $CategoryName2 = "Catégorie n°2";
		public $CategoryName3 = "Catégorie n°3";
		public $CategoryName4 = "Catégorie n°4";
		
		public $Resync = 0;
		public $ReExportSales = 0;
		public $ReExportCustomers = 0;
		
		public $SupplierID = 0;
		public $SupplierBackupID = 0;
		public $LangID = 1;
		public $CatalogShopID = 0;
		public $PricesShopID = 0;
		public $CurrencyID = 1;
		public $AccessKey = "";
		public $AccessActive = false;
		
		public $CustomersGroupID = 0;
		public $OrderExportStateID = NULL;
		
		public $DefaultCategoryRoot = 0;
		public $AutoCategory = true;
		public $SortingCategoryID = 0;
		
		public $DefaultWeigth = 0;
		public $VisibilityWhenSoldOut = "none";

		public $CategoryRoot = 0;
		public $CategoryForTags = 0;
		public $CategoryForRFS = 0;
		public $CategoryForCollection = 0;
		public $CategoryForSeason = 0;
		public $CategoryForCategory1 = 0;
		public $CategoryForCategory2 = 0;
		public $CategoryForCategory3 = 0;
		public $CategoryForCategory4 = 0;
		public $CategoryForManufacturer = 0;

		public $UseLevel1ForSize = 0;
		public $UseLevel2ForSize = 0;
		public $UseLevel3ForSize = 0;
		public $UseLevel4ForSize = 0;

		public $AttrGroupForAttr0 = 0;
		public $AttrGroupForAttr1 = 0;
		public $AttrGroupForAttr2 = 0;
		public $AttrGroupForAttr3 = 0;
		public $AttrGroupForAttr4 = 0;

		public $AttrGroupForAttrG1 = 0;
		public $AttrGroupForAttrG2 = 0;
		public $AttrGroupForAttrG3 = 0;
		public $AttrGroupForAttrG4 = 0;

		public $FeatureForAttr1 = 0;
		public $FeatureForAttr2 = 0;
		public $FeatureForAttr3 = 0;
		public $FeatureForAttr4 = 0;

		public $FeatureForAttrG1 = 0;
		public $FeatureForAttrG2 = 0;
		public $FeatureForAttrG3 = 0;
		public $FeatureForAttrG4 = 0;

		public $FeatureForCategory1 = 0;
		public $FeatureForCategory2 = 0;
		public $FeatureForCategory3 = 0;
		public $FeatureForCategory4 = 0;

		public $FeatureForSeason = 0;
		public $FeatureForCollection = 0;
		
		public $MethodTags = 0;	// 0 => non géré, 1 => catégorie, 2 => caractéristiques, 3 => mot clés
		public $SlugBuildMethod = "{reference}-{manufacturer}"; // 0 => référence + marque, 1 => référence, 2 => nom produit
		
		public $OPT_SIZE_GRID = false;
		public $OPT_ACTIVE_PUBLISHED = false;
		public $OPT_PAYMENT_MODULE = false;

		// Stock de sécurité
		public $StockMini = 0;

		public $OPT_UNPUBLISH_COOLDOWN = false;

		public $OPT_REFS_CACHE = true;
		public $OPT_USE_ADV_STOCK = false;
		public $OPT_USE_EAN_STOCK = true;
		public $OPT_USE_ARCHIVES = false;
		public $OPT_ALLOW_I_PHOTOS = true;
		public $OPT_ALLOW_I_NAME = true;
		public $OPT_ALLOW_I_DESCRIPTIONS = true;
		public $OPT_ALLOW_I_MDESCRIPTIONS = true;
		public $OPT_ALLOW_I_PRODUCT_LINK = false;
		public $OPT_ALLOW_I_GENDERS = true;
		public $OPT_ALLOW_I_CUSTOMERS = true;
		public $OPT_ALLOW_E_CUSTOMERS = true;
		public $OPT_ALLOW_E_MK_CUSTOMERS = true;
		public $OPT_ALLOW_E_G_CUSTOMERS = true;
		public $OPT_ALLOW_E_SALES = true;
		public $OPT_ALLOW_E_SALES_OTHER_CURRENCIES = false;
		public $OPT_ALLOW_I_STOCKS = true;
		public $OPT_ALLOW_I_SALE_PRICES = true;
		public $OPT_ALLOW_I_PROMOS = true;
		public $OPT_ALLOW_I_CATALOG = true;

		public $OPT_ALLOW_I_VOUCHERS_ASSETS = true;
		public $OPT_ALLOW_I_VOUCHERS_OFFERS = true;

		public $OPT_PROMO_AMOUNT = false;

		public $OPT_NO_SYMLNK_IMG = false;
		
		public static function createMultiLangField($field)
		{
			$res = array();
			foreach (Language::getIDs(false) as $id_lang) {
				$res[$id_lang] = $field;
			}

			return $res;
		}
		
		public function setLangField($field, $value)
		{
			if ($field == null)
				$field = array();
			
			foreach (Language::getIDs(false) as $id_lang) {
				if (!isset($field[$id_lang]) || empty($field[$id_lang]) || $id_lang == $this->LangID)
					$field[$id_lang] = $value;
			}
			
			return $field;
		}
		
		private function GetOrCreateAttributesGroup(&$existingGroups, $group)
		{
			foreach ($existingGroups as $egroup)
			{
				if ($egroup["name"] == $group || $egroup["name"] == $group." (à renommer)")
					return $egroup["id_attribute_group"];
			}
			
			// Création !
			$id_lang = Configuration::get('PS_LANG_DEFAULT');
			
			$ngroup = new AttributeGroup();
			$ngroup->name = PolarisLinkSite::createMultiLangField($group);
			$ngroup->public_name = PolarisLinkSite::createMultiLangField($group);
			$ngroup->group_type = "select";
			$ngroup->add();
			
			return $ngroup->id;
		}
		
		private function IsCategoryExists($no_category)
		{
			if (!$no_category)
				return false;
			$category = new Category($no_category);
			return $category->id == $no_category;
		}
		
		private function IsAttributeGroupExists($no_attr_group)
		{
			if (!$no_attr_group)
				return false;
			$attrsGroup = new AttributeGroup($no_attr_group);
			return $attrsGroup->id == $no_attr_group;
		}
		
		private function GetOrCreateCategorie(&$existingCategories, $racine, $categorie)
		{
			foreach ($existingCategories as $ecat)
			{
				if ($ecat["name"] == $categorie || $ecat["name"] == $categorie." (à renommer)")
					return $ecat["id_category"];
			}
			
			// Création !
			$id_lang = Configuration::get('PS_LANG_DEFAULT');
			
			$ncat = new Category();
			$ncat->name = PolarisLinkSite::createMultiLangField($categorie);
			$ncat->link_rewrite = PolarisLinkSite::createMultiLangField(Tools::link_rewrite($categorie));
			$ncat->id_parent = $racine;
			$ncat->active = false;
			$ncat->is_root_category = false;
			$ncat->add();
			
			return $ncat->id;
		}
		
		private function IsSupplierExists($no_supplier)
		{
			if (!$no_supplier)
				return false;
			$supplier = new Supplier($no_supplier);
			return $supplier->id == $no_supplier;
		}
		
		private function GetOrCreateSupplier($name, $description)
		{
			$supplier = Supplier::getIdByName($name);
			if (!$supplier)
			{
				// Autocréation si le fournisseur n'existe pas
				$supplier = new Supplier();
				$supplier->name = $name;
				$supplier->description = $description;
				$supplier->active = true;
				$supplier->save();	
				
				return intval($supplier->id);
			}
			else
				return $supplier;
		}
		
		private function IsCustomersGroupExists($no_customers_group)
		{
			if (!$no_customers_group)
				return false;
			$customers_group = new Group($no_customers_group);
			return $customers_group->id == $no_customers_group;
		}
		
		private function GetOrCreateCustomersGroup($name)
		{
			foreach (Group::getGroups(Configuration::get('PS_LANG_DEFAULT')) as $group)
			{
				if ($group["name"] == $name)
					return intval($group["id_group"]);
			}
			
			// Autocréation si le groupe n'existe pas
			$group = new Group();
			$group->name = PolarisLinkSite::createMultiLangField($name);
			$group->price_display_method = 0;
			$group->save();
			
			$modules = array();
			foreach (Module::getModulesInstalled() as $module)
				$modules[] = intval($module["id_module"]);			
			Group::addModulesRestrictions($group->id, $modules, array($this->CatalogShopID));
			
			return intval($group->id);
		}
		
		private function IsProfileExists($no_profile)
		{
			if (!$no_profile)
				return false;
			$profile = new Profile($no_profile);
			return $profile->id == $no_profile;
		}
		
		private function GetOrCreateProfil($name)
		{
			$profile = false;
			foreach (Profile::getProfiles(Configuration::get('PS_LANG_DEFAULT')) as $p)
			{
				if ($p["name"] == $name)
				{
					$profile = new Profile($p["id_profile"]);
					break;
				}
			}

			if (!$profile)
			{
				// Autocréation si le fournisseur n'existe pas
				$profile = new Profile();
				$profile->name = PolarisLinkSite::createMultiLangField($name);
				$profile->save();				
			}
			return intval($profile->id);
		}		
		
		public function checkConfig()
		{
			$db = Db::getInstance();
			$id_lang = Configuration::get('PS_LANG_DEFAULT');
			
			// Contrôle de la configuration !
			$before = json_encode($this);
									
			if (!$this->IsCustomersGroupExists($this->CustomersGroupID))
				$this->CustomersGroupID = $this->GetOrCreateCustomersGroup("Clients Polaris");
			
			if (!$this->IsSupplierExists($this->SupplierID))
				$this->SupplierID = $this->GetOrCreateSupplier("Polaris", "Ce fournisseur est créé automatiquement par la passerelle PolarisLink. Veuillez ne pas le modifier, ni le supprimer.");
			
			if (!$this->IsSupplierExists($this->SupplierBackupID))
				$this->SupplierBackupID = $this->GetOrCreateSupplier("PolarisReprise", "Ce fournisseur est créé automatiquement par la passerelle PolarisLink. Veuillez ne pas le modifier, ni le supprimer.");			
			
			$categories = Category::getAllCategoriesName(null, false, false, null, false);
			$attrsGroup = AttributeGroup::getAttributesGroups($id_lang);						

			$classificationPolaris = $this->CategoryRoot;			
			if ($classificationPolaris == 0 || $classificationPolaris == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($classificationPolaris))
			{
				$classificationPolaris = $this->GetOrCreateCategorie($categories, Configuration::get('PS_HOME_CATEGORY'), "Classification Polaris");
				$this->CategoryRoot = $classificationPolaris;
			}
			
			if ($this->SortingCategoryID == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->SortingCategoryID)) $this->SortingCategoryID = $this->GetOrCreateCategorie($categories, (int)Configuration::get('PS_ROOT_CATEGORY'), "A classer");
				
			if ($this->CategoryForRFS == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForRFS)) $this->CategoryForRFS = $this->GetOrCreateCategorie($categories, $classificationPolaris, "RFS Polaris");
			if ($this->CategoryForTags == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForTags)) $this->CategoryForTags = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Thèmes Polaris");
			if ($this->CategoryForSeason == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForSeason)) $this->CategoryForSeason = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Saisons Polaris");
			if ($this->CategoryForCollection == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForCollection)) $this->CategoryForCollection = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Collections Polaris");
			if ($this->CategoryForCategory1 == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForCategory1)) $this->CategoryForCategory1 = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Catégories 1 Polaris");
			if ($this->CategoryForCategory2 == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForCategory2)) $this->CategoryForCategory2 = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Catégories 2 Polaris");
			if ($this->CategoryForCategory3 == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForCategory3)) $this->CategoryForCategory3 = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Catégories 3 Polaris");
			if ($this->CategoryForCategory4 == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->CategoryForCategory4)) $this->CategoryForCategory4 = $this->GetOrCreateCategorie($categories, $classificationPolaris, "Catégories 4 Polaris");

			if ($this->DefaultCategoryRoot == (int)Configuration::get('PS_ROOT_CATEGORY') || !$this->IsCategoryExists($this->DefaultCategoryRoot)) 
				$this->DefaultCategoryRoot = $this->CategoryForRFS;
			
			if (empty($this->AttrGroupForAttr0) || !$this->IsAttributeGroupExists($this->AttrGroupForAttr0))
				$this->AttrGroupForAttr0 = $this->GetOrCreateAttributesGroup($attrsGroup, "Taille");

			if (!empty($this->AttrGroupForAttr1) && !$this->IsAttributeGroupExists($this->AttrGroupForAttr1))
				$this->AttrGroupForAttr1 = 0;
			if (!empty($this->AttrGroupForAttr2) && !$this->IsAttributeGroupExists($this->AttrGroupForAttr2))
				$this->AttrGroupForAttr2 = 0;
			if (!empty($this->AttrGroupForAttr3) && !$this->IsAttributeGroupExists($this->AttrGroupForAttr3))
				$this->AttrGroupForAttr3 = 0;
			if (!empty($this->AttrGroupForAttr4) && !$this->IsAttributeGroupExists($this->AttrGroupForAttr4))
				$this->AttrGroupForAttr4 = 0;
			
			if (!empty($this->AttrGroupForAttrG1) && !$this->IsAttributeGroupExists($this->AttrGroupForAttrG1))
				$this->AttrGroupForAttrG1 = 0;
			if (!empty($this->AttrGroupForAttrG2) && !$this->IsAttributeGroupExists($this->AttrGroupForAttrG2))
				$this->AttrGroupForAttrG2 = 0;
			if (!empty($this->AttrGroupForAttrG3) && !$this->IsAttributeGroupExists($this->AttrGroupForAttrG3))
				$this->AttrGroupForAttrG3 = 0;
			if (!empty($this->AttrGroupForAttrG4) && !$this->IsAttributeGroupExists($this->AttrGroupForAttrG4))
				$this->AttrGroupForAttrG4 = 0;
			
			$after = json_encode($this);
			
			return $before != $after;
		}
			
		public function __construct()
		{
			$this->LangID = Configuration::get('PS_LANG_DEFAULT');
			$this->CatalogShopID = array(Configuration::get('PS_SHOP_DEFAULT'));
			$this->PricesShopID = array(Configuration::get('PS_SHOP_DEFAULT'));
		}
		
		public static function loadConfig()
		{
			$db = Db::getInstance();
			
			$rows = $db->executeS("SELECT * FROM "._DB_PREFIX_."polarislink_sites");
			if ($rows === false)
				throw new PrestaShopDatabaseException($db->getMsgError());

			$configs = array();
			foreach ($rows as $row)
			{
				$cfg = unserialize($row["cfg"]);
				$cfg->LinkID = $row["id_link"];
				
				$configs[] = $cfg;				
			}
			
			return $configs;
		}

		/*
			Rechargement et renvoi de la configuration
		*/
		public function reloadConfig()
		{
			$db = Db::getInstance();
			
			$rows = $db->executeS("SELECT * FROM "._DB_PREFIX_."polarislink_sites WHERE id_link = ".$this->LinkID);

			if ($rows === false)
				throw new PrestaShopDatabaseException($db->getMsgError());

			foreach ($rows as $row)
				return unserialize($row["cfg"]);

			return NULL;
		}
		
		/*
			Change une valeur de configuration
		*/
		public function change($property, $newValue)
		{			
			if ($this->$property === $newValue)
				return;	// pas de changement

			$displayOld = is_array($this->$property) ? join(', ', $this->$property) : $this->$property;
			$displayNew = is_array($newValue) ? join(', ', $newValue) : $newValue;
			
			PolarisLink::Log(LOG_INFO, "Chg. config. : %s = %s → %s", $this->LinkID, [ $property, $displayOld, $displayNew ]);
			
			$this->$property = $newValue;
		}
		
		public function delete()
		{
			$db = Db::getInstance();
			if (!$db->delete("polarislink_sites", 'id_link = '.$this->LinkID, 0, false))
				throw new Exception($db->getMsgError());
		}
		
		public function save()
		{
			$db = Db::getInstance();
			
			if (empty($this->LinkID))
			{
				if (!$db->insert("polarislink_sites", array("cfg" => ""), false, false))
					throw new Exception($db->getMsgError());
				$this->LinkID = $db->Insert_ID();
			}
			
			if (!$db->update("polarislink_sites", array("cfg" => serialize($this)), 'id_link = '.$this->LinkID, 0, false, false))
				throw new Exception($db->getMsgError());
			
			return $this;
		}
	}