<?php
	/*
	* 2018 - VEGA Informatique
	*
	* NOTICE OF LICENSE
	*
	* This source file is subject to the Open Software License (OSL 3.0)
	* that is bundled with this package in the file LICENSE.txt.
	* It is also available through the world-wide-web at this URL:
	* http://opensource.org/licenses/osl-3.0.php
	*
	* DISCLAIMER
	*
	* Do not edit or add to this file if you wish to upgrade PolarisLink to newer
	* versions in the future. 
	*
	*  @author VEGA Informatique <contact@vega-info.fr>
	*  @copyright  2018 VEGA Informatique
	*  @license    http://opensource.org/licenses/osl-3.0.php  Open Software License (OSL 3.0)
	*/

	if (!defined('_PS_VERSION_'))
		exit;	
		
	function upgrade_module_4_08($module)
	{		
		try
		{
            /* On ajoute une table pour stocker des informations supplémentaires sur les opérations commerciales */
			$db = Db::getInstance();
			
			// Création de la table de dépublication
			if (!$db->execute("CREATE TABLE `"._DB_PREFIX_."polarislink_products` (
                id_product INT(10) UNSIGNED NOT NULL,
                date_depublication DATETIME DEFAULT NULL,
                                            
                PRIMARY KEY (id_product)
                ) ENGINE="._MYSQL_ENGINE_." DEFAULT CHARSET=utf8;")) 
                throw new Exception("impossible de créer la table polarislink_products");			

            if (!$db->execute("ALTER TABLE `"._DB_PREFIX_."polarislink_products` ADD CONSTRAINT `FK_polarislink_products` FOREIGN KEY (`id_product`) REFERENCES `"._DB_PREFIX_."product` (`id_product`) ON UPDATE CASCADE ON DELETE CASCADE;")) 
                throw new Exception(sprintf("impossible de lier la table %s à %s", "polarislink_products", "product"));
		}
		catch (Exception $ex)
		{
			$module->install_error(Tools::displayError($ex));			
			return false;
		}
				
		return true;
	 }
 